io.vertx.core.file

## Interface AsyncFile

- All Superinterfaces:
    ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public interface AsyncFile
      extends ReadStream<Buffer>, WriteStream<Buffer>

  Represents a file on the file-system which can be read from, or written to asynchronously.

  This class also implements `ReadStream` and `WriteStream`. This allows the data to be piped to and from other streams, e.g. an `HttpClientRequest` instance, using the `Pipe` class

  Author:
    Tim Fox

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `Future<Void>` | `close()` Close the file.
    `void` | `close(Handler<AsyncResult<Void>> handler)` Close the file.
    `AsyncFile` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `AsyncFile` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `AsyncFile` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `AsyncFile` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `Future<Void>` | `flush()` Flush any writes made to this file to underlying persistent storage.
    `AsyncFile` | `flush(Handler<AsyncResult<Void>> handler)` Same as `flush()` but the handler will be called when the flush is complete or if an error occurs
    `long` | `getReadLength()`
    `long` | `getWritePos()`
    `AsyncFile` | `handler(Handler<Buffer> handler)` Set a data handler.
    `AsyncFile` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Future<Buffer>` | `read(Buffer buffer, int offset, long position, int length)` Like `read(Buffer, int, long, int, Handler)` but returns a `Future` of the asynchronous result
    `AsyncFile` | `read(Buffer buffer, int offset, long position, int length, Handler<AsyncResult<Buffer>> handler)` Reads `length` bytes of data from the file at position `position` in the file, asynchronously.
    `AsyncFile` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `AsyncFile` | `setReadBufferSize(int readBufferSize)` Sets the buffer size that will be used to read the data from the file.
    `AsyncFile` | `setReadLength(long readLength)` Sets the number of bytes that will be read when using the file as a `ReadStream`.
    `AsyncFile` | `setReadPos(long readPos)` Sets the position from which data will be read from when using the file as a `ReadStream`.
    `AsyncFile` | `setWritePos(long writePos)` Sets the position from which data will be written when using the file as a `WriteStream`.
    `AsyncFile` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `Future<Long>` | `size()`
    `default void` | `size(Handler<AsyncResult<Long>> handler)` Like `size()` but the `handler` will be called when the operation is complete or if an error occurs.
    `long` | `sizeBlocking()` Like `size()` but blocking.
    `Future<Void>` | `write(Buffer buffer, long position)` Like `write(Buffer, long, Handler)` but returns a `Future` of the asynchronous result
    `void` | `write(Buffer buffer, long position, Handler<AsyncResult<Void>> handler)` Write a `Buffer` to the file at position `position` in the file, asynchronously.

    - ### Methods inherited from interface io.vertx.core.streams.ReadStream

      `pipe, pipeTo, pipeTo`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, end, end, write, write, writeQueueFull`

- - ### Method Detail

    - #### handler

          AsyncFile handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          AsyncFile pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          AsyncFile resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          AsyncFile endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          AsyncFile setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          AsyncFile drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          AsyncFile exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          AsyncFile fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### close

          Future<Void> close()

      Close the file. The actual close happens asynchronously.
      Returns:
        a future completed with the result

    - #### close

          void close(Handler<AsyncResult<Void>> handler)

      Close the file. The actual close happens asynchronously. The handler will be called when the close is complete, or an error occurs.
      Parameters:
        `handler` - the handler

    - #### write

          void write(Buffer buffer,
                     long position,
                     Handler<AsyncResult<Void>> handler)

      Write a `Buffer` to the file at position `position` in the file, asynchronously.

      If `position` lies outside of the current size of the file, the file will be enlarged to encompass it.

      When multiple writes are invoked on the same file there are no guarantees as to order in which those writes actually occur

      The handler will be called when the write is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to write
        `position` - the position in the file to write it at
        `handler` - the handler to call when the write is complete

    - #### write

          Future<Void> write(Buffer buffer,
                             long position)

      Like `write(Buffer, long, Handler)` but returns a `Future` of the asynchronous result

    - #### read

          AsyncFile read(Buffer buffer,
                         int offset,
                         long position,
                         int length,
                         Handler<AsyncResult<Buffer>> handler)

      Reads `length` bytes of data from the file at position `position` in the file, asynchronously.

      The read data will be written into the specified `Buffer buffer` at position `offset`.

      If data is read past the end of the file then zero bytes will be read.

      When multiple reads are invoked on the same file there are no guarantees as to order in which those reads actually occur.

      The handler will be called when the close is complete, or if an error occurs.

      Parameters:
        `buffer` - the buffer to read into
        `offset` - the offset into the buffer where the data will be read
        `position` - the position in the file where to start reading
        `length` - the number of bytes to read
        `handler` - the handler to call when the write is complete
      Returns:
        a reference to this, so the API can be used fluently

    - #### read

          Future<Buffer> read(Buffer buffer,
                              int offset,
                              long position,
                              int length)

      Like `read(Buffer, int, long, int, Handler)` but returns a `Future` of the asynchronous result

    - #### flush

          Future<Void> flush()

      Flush any writes made to this file to underlying persistent storage.

      If the file was opened with `flush` set to `true` then calling this method will have no effect.

      The actual flush will happen asynchronously.

      Returns:
        a future completed with the result

    - #### flush

          AsyncFile flush(Handler<AsyncResult<Void>> handler)

      Same as `flush()` but the handler will be called when the flush is complete or if an error occurs

    - #### setReadPos

          AsyncFile setReadPos(long readPos)

      Sets the position from which data will be read from when using the file as a `ReadStream`.
      Parameters:
        `readPos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### setReadLength

          AsyncFile setReadLength(long readLength)

      Sets the number of bytes that will be read when using the file as a `ReadStream`.
      Parameters:
        `readLength` - the bytes that will be read from the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### getReadLength

          long getReadLength()

      Returns:
        the number of bytes that will be read when using the file as a `ReadStream`

    - #### setWritePos

          AsyncFile setWritePos(long writePos)

      Sets the position from which data will be written when using the file as a `WriteStream`.
      Parameters:
        `writePos` - the position in the file
      Returns:
        a reference to this, so the API can be used fluently

    - #### getWritePos

          long getWritePos()

      Returns:
        the current write position the file is at

    - #### setReadBufferSize

          AsyncFile setReadBufferSize(int readBufferSize)

      Sets the buffer size that will be used to read the data from the file. Changing this value will impact how much the data will be read at a time from the file system.
      Parameters:
        `readBufferSize` - the buffer size
      Returns:
        a reference to this, so the API can be used fluently

    - #### sizeBlocking

          long sizeBlocking()

      Like `size()` but blocking.
      Throws:
        `FileSystemException` - if an error occurs

    - #### size

          default void size(Handler<AsyncResult<Long>> handler)

      Like `size()` but the `handler` will be called when the operation is complete or if an error occurs.

    - #### size

          Future<Long> size()

      Returns:
        the size of the file

Copyright © 2021 Eclipse. All rights reserved.